#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), remove when upstream will support it
%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

Summary:	Polimorphic XML Parser for OCaml
Summary(pl.UTF-8):	Polimorficzny analizator składniowy XML-a dla OCamla
Name:		ocaml-pxp
Version:	1.2.9
Release:	1
License:	distributable
Group:		Libraries
Source0:	http://download.camlcity.org/download/pxp-%{version}.tar.gz
# Source0-md5:	8002253eade813b8355500f4c59f8da8
URL:		http://projects.camlcity.org/projects/pxp.html
BuildRequires:	ocaml >= 1:3.09.2
BuildRequires:	ocaml-camlp4
BuildRequires:	ocaml-findlib
BuildRequires:	ocaml-ocamldoc-devel
BuildRequires:	ocaml-net-netstring-devel >= 3.6-2
BuildRequires:	ocaml-net-netsys-devel >= 3.6-2
BuildRequires:	ocaml-net-netunidata-devel
BuildRequires:	ocaml-ulex
BuildRequires:	sed >= 4.0
BuildConflicts:	ocaml-wlex-devel
%requires_eq	ocaml-ulex
%requires_eq	ocaml-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PXP is a validating parser for XML 1.0 which has been written entirely
in Objective Caml.

PXP means "Polymorphic XML Parser" and emphasizes its most useful
property: that the API is polymorphic and can be configured such that
different objects are used to store different types of elements.

%description -l pl.UTF-8
PXP jest walidującym analizatorem składniowym XML-a 1.0, napisanym w
całości w OCamlu.

PXP oznacza "Polymorphic XML Parser" (polimorficzny analizator
składniowy XML-a), co podkreśla jego najbardziej użyteczną własność:
API jest polimorficzne i może być skonfigurowane tak, że różne obiekty
są używane do przechowywania różnych typów elementów.

%package devel
Summary:	Polimorphic XML Parser for OCaml - development part
Summary(pl.UTF-8):	Polimorficzny analizator składniowy XML-a dla OCamla - cześć programistyczna
Group:		Development/Libraries
%requires_eq	ocaml
%requires_eq	ocaml-net-netstring-devel

%description devel
PXP is a validating parser for XML 1.0 which has been written entirely
in Objective Caml.

PXP means "Polymorphic XML parser" and emphasizes its most useful
property: that the API is polymorphic and can be configured such that
different objects are used to store different types of elements.

This package contains files needed to develop OCaml programs using the
PXP library.

%description devel -l pl.UTF-8
PXP jest walidującym analizatorem składniowym XML-a 1.0, napisanym w
całości w OCamlu.

PXP oznacza "Polymorphic XML Parser" (polimorficzny analizator
składniowy XML-a), co podkreśla jego najbardziej użyteczną własność:
API jest polimorficzne i może być skonfigurowane tak, że różne obiekty
są używane do przechowywania różnych typów elementów.

Pakiet ten zawiera pliki niezbędne do tworzenia programów używających
biblioteki PXP.

%prep
%setup -q -n pxp-%{version}

%build
./configure \
	-with-lex \
	-with-ulex \
	-without-wlex \
	-with-pp

sed -i -e 's/-g//' Makefile.rules
%{__make} -j1 \
	all %{?with_ocaml_opt:opt}

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/{site-lib,pxp}
OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib %{__make} install
dir=`pwd`
cd $RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib
for f in * ; do
	echo 'directory = "+pxp"' >> $f/META
	if [ "`echo $f/*.*`" != "$f/*.*" ]; then
		mv $f/*.* $RPM_BUILD_ROOT%{_libdir}/ocaml/pxp
	fi
done
cd $dir

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -r examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(644,root,root,755)
%doc doc/README doc/SPEC
%doc doc/design.txt doc/manual/html
%dir %{_libdir}/ocaml/pxp
%{_libdir}/ocaml/pxp/*.cm[xi]
%{_libdir}/ocaml/pxp/*.cma
%{_libdir}/ocaml/pxp/*.cmo
%{_libdir}/ocaml/pxp/*.mli
%if %{with ocaml_opt}
%{_libdir}/ocaml/pxp/*.[ao]
%{_libdir}/ocaml/pxp/*.cmxa
%endif
%{_examplesdir}/%{name}-%{version}
%{_libdir}/ocaml/site-lib/*
%changelog
* Mon Jun 05 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-pxp.git;a=log;h=master

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 3b39e9e
- up to 1.2.9

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 2d5a43f
- rebuild with ocaml 4.04.1
- release 4 (by relup.sh)

* Mon Mar 21 2016 Jan Rękorajski <baggins@pld-linux.org> 760c3eb
- release 3 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> f233a9c
- added ocaml_opt bcond
- rel 2

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 930bf14
- up to 1.2.4

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> a97cace
- rebuild with ocaml 4.02
- release 3 (by relup.sh)

* Mon Sep 24 2012 Jan Rękorajski <baggins@pld-linux.org> 3feec13
- rebuild with fixed rpm macros
- release 2 (by relup.sh)

* Sun Sep 23 2012 Jan Rękorajski <baggins@pld-linux.org> 86de20c
- updated BRs and files

* Sun Sep 23 2012 Jan Rękorajski <baggins@pld-linux.org> 063e843
- updated BRs

* Sun Sep 23 2012 Jan Rękorajski <baggins@pld-linux.org> 8da13f2
- updated to 1.2.3
- new homepage

* Mon Jul 18 2011 Jan Rękorajski <baggins@pld-linux.org> eb36b6e
- 1.2.2
- use ulex instead of outdated and umnaintained wlex

* Mon Jul 18 2011 Jan Rękorajski <baggins@pld-linux.org> d621a6c
- release 11

* Sat Apr 18 2009 areq <areq@pld-linux.org> e6e517e
- rel 10

* Thu Jul 10 2008 Marcin Banasiak <marcin.banasiak@gmail.com> 14cce90
- release 9

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 2459520
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 6dbe4d6
- converted to UTF-8

* Wed May 31 2006 Elan Ruusamäe <glen@pld-linux.org> 6e06488
- rel 8 (rebuild with ocaml-3.09.2)

* Sun Apr 16 2006 Elan Ruusamäe <glen@pld-linux.org> 42ed066
- ocaml epoch is 1

* Sat Apr 15 2006 Elan Ruusamäe <glen@pld-linux.org> 7ab9379
- ocaml 3.09.1

* Fri Dec 30 2005 Jan Rękorajski <baggins@pld-linux.org> 7bbb49a
- rel 5
- BR ocaml-netclient 1.1.1

